#ifndef KERNEL_HEADER
#define KERNEL_HEADER

#include "process.h"

struct RunQ {
	struct Process *current_proc;
	size_t max_procs;
	size_t proc_amount;
	size_t next_proc_id;
};

struct RunQ *RunQ(size_t max_procs);
void RUNQ_add_process(size_t max_page_accesses, size_t total_pages_owned);



struct PhysPage {
	size_t ppn;
	size_t busy_flag;
	struct PhysPage *prev;
	struct PhysPage *next;
	struct PageTableEntry *pt;
	size_t pt_index;
};


void KERNEL_page_fault(struct PageTableEntry *pt, size_t page_no);

#endif
