#include <stdio.h>
#include <process.h>
#include <stdlib.h>

#include "kernel.h"
#include "random.h"

#include "config.h"


struct RunQ *runq;

struct PhysPage *first_free_page;
struct PhysPage *first_busy_page;

int
main(void)
{
	first_busy_page = NULL;
	
	first_free_page = malloc(sizeof(struct PhysPage));
	first_free_page->ppn = 0;
	first_free_page->busy_flag = 0;
	first_free_page->prev = first_free_page;
	first_free_page->next = first_free_page;

	for (int i = 1; i <= PHYSICAL_PAGE_AMOUNT; i++) {
		struct PhysPage *pp = malloc(sizeof(struct PhysPage));
		pp->ppn = i;
		pp->busy_flag = 0;

		/*
		 *      insert pp into here
		 *               |
		 *               v
		 *           [ ]   [ ]   [ ]
		 *                  ^
		 *                  |
		 *          *first_free_page
		 */
		pp->prev = first_free_page->prev;
		pp->next = first_free_page; 
		pp->next->prev = pp;
		pp->prev->next = pp;
	}

	runq = RunQ(10);

	for (size_t i = 0; i < 5; i++) {
		RUNQ_add_process(10000, 10 + randint(70));
	}

	for (int i = 0; i < 20; i++) {
		PROCESS_run_for(runq->current_proc, 20);
		runq->current_proc = runq->current_proc->next;
	}
}
